%{


#include<stdio.h>
#include<string.h>

#include "compilador.h"
#include "compilador.tab.h"

#define IMPRIME(STR) {};
//#define IMPRIME(STR) printf("%s    # %s \n", STR, token);

int nl = 1;  

%}

pulo_linha [\n]

descarte [\t ]+

ident [a-zAZ][a-zAZ1-9]*

numero [0-9]+

comentario "(*".*"*)"

%%

{pulo_linha} {nl++;} 

{descarte}

{comentario}

program {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME("program ");
	return PROGRAM;
}

var {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME("var  ");
	return VAR;
}
	
begin {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME("begin ");
	return T_BEGIN;
}

end {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME("end  ");
	return T_END;
}

procedure {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME("procedure ");
	return PROCEDURE;
}

function {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME("function ");
	return FUNCTION;
}

:= {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" atribuicao  ");
	return ATRIBUICAO;  
}

\; {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" pt_virgula  ");
	return PONTO_E_VIRGULA;
}

\: {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" dois pontos ");
	return DOIS_PONTOS;
}

\, {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" virgula  ");
	return VIRGULA;
}


\. {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" ponto  ");
	return PONTO; 
}

\(  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" abre_parenteses  ");
	return ABRE_PARENTESES;
}

\)  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" fecha_parenteses ");
	return FECHA_PARENTESES;
}

\+  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" mais ");
	return MAIS;
}

\-  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" menos ");
	return MENOS;
}

\*  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" mult ");
	return MULT;
}

\=  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" igual ");
	return IGUAL;
}

\>  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" maior ");
	return MAIOR;
}

\<  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" menor ");
	return MENOR;
}

\>=  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" maior_igual ");
	return MAIOR_IGUAL;
}

\<=  { 
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" menor_igual ");
	return MENOR_IGUAL;
}


!=  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" diff ");
	return DIFF;
}

\/  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" div ");
	return DIV;
}

or  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" or ");
	return OR;
}

and  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" and ");
	return AND;
}

do  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" do ");
	return DO;
}

while  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" while ");
	return WHILE;
}

if  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" if ");
	return IF;
}

then  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" then ");
	return THEN;
}

else  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" else ");
	return ELSE;
}

type  {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" type ");
	return TYPE;
}

{numero} {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" numero  ");
	return NUMERO;
}

{ident} {
	strncpy (token, yytext, TAM_TOKEN);
	IMPRIME(" ident  ");
	return IDENT;
}


%%

