%{

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include "compilador.h"


char token[TAM_TOKEN];
char var_token[TAM_TOKEN];
char function_token[TAM_TOKEN];
int nl;

VarPkg VARPKG;
Code   CODE;

%}

%token PROGRAM ABRE_PARENTESES FECHA_PARENTESES 
%token VIRGULA PONTO_E_VIRGULA DOIS_PONTOS PONTO
%token T_BEGIN T_END VAR IDENT ATRIBUICAO NUMERO
%token MAIS MENOS OR MULT DIV AND IGUAL DIFF MAIOR MENOR MAIOR_IGUAL MENOR_IGUAL
%token DO WHILE IF THEN ELSE PROCEDURE FUNCTION
%token TYPE

%%

program:
	PROGRAM IDENT {printf("{name='%s';",token);}
	ABRE_PARENTESES lista_idents FECHA_PARENTESES PONTO_E_VIRGULA
	bloco PONTO {printf("}\n",token);};

bloco:
	typeblock
	{printf("variables=[");}
	parte_declara_vars 
	{printf("];functions=[");}
	parte_subrotinas
	{printf("];code=[");}
	comando_composto
	{printf("];");};

typeblock:
	TYPE
	| ;

parte_subrotinas:
	parte_subrotinas subrotina;
	| ;


subrotina:
	FUNCTION IDENT {printf("{name='%s';",token);}
	param_formais DOIS_PONTOS IDENT {printf("out='%s';",token);} PONTO_E_VIRGULA
	bloco PONTO_E_VIRGULA {printf("};");}

	| PROCEDURE IDENT {printf("{name='%s';out='';",token);}
	param_formais PONTO_E_VIRGULA
	bloco PONTO_E_VIRGULA {printf("};");};


param_formais:
	ABRE_PARENTESES{printf("params=[");} lista_param {printf("];");}FECHA_PARENTESES
	| {printf("params=[];");};

lista_param:
	lista_param PONTO_E_VIRGULA param 
	| param
	| ;

param:
	lista_id_param DOIS_PONTOS IDENT {VarPkg_write(&VARPKG, token);}
	| VAR lista_id_param DOIS_PONTOS IDENT {VarPkg_write(&VARPKG, token);};

lista_id_param:
	lista_id_param VIRGULA IDENT {VarPkg_add(&VARPKG, token);}
	| IDENT {VarPkg_add(&VARPKG, token);};



parte_declara_vars:
	var;

var:
	VAR declara_vars
	| ;

declara_vars:
	declara_vars declara_var
	| declara_var;

declara_var:
	lista_id_var DOIS_PONTOS IDENT{VarPkg_write(&VARPKG, token);} PONTO_E_VIRGULA;

lista_id_var:
	lista_id_var VIRGULA IDENT {VarPkg_add(&VARPKG, token);}
	| IDENT {VarPkg_add(&VARPKG, token);};

lista_idents:
	lista_idents VIRGULA IDENT
	| IDENT;


comando_composto:
	T_BEGIN comandos T_END;

comandos:
	comandos PONTO_E_VIRGULA comando
	| comando
	| ;

comando:
	expressao {Code_write(&CODE, nl);}
	| comando_repetitivo 
	| comando_condicional
	| comando_composto;

subif_comando:
	expressao
	| comando_repetitivo
	| comando_composto;


comando_condicional:
	if_then else_ifs last_else;

if_then:
	IF {printf("Switch{cases=[{cnd=");} expressao {printf("};code=[");} THEN
		subif_comando {printf("]};");};

else_ifs:
	else_ifs else_if
	| ;

else_if:
	ELSE IF expressao THEN
		subif_comando;

last_else:
	ELSE subif_comando
	| %prec LOWER_THAN_ELSE;


comando_repetitivo:
	WHILE {printf("While{cnd=");} expressao {Code_write(&CODE, nl);printf("code=[");}
	DO comando {printf("];};");};


expressao:
	expressao1

	| expressao3 
	ATRIBUICAO 
	expressao1 {Code_useOp(&CODE, ":=");}

	|expressao1
	IGUAL 
	expressao1 {Code_useOp(&CODE, "=");}

	| expressao1
	DIFF 
	expressao1 {Code_useOp(&CODE, "<>");}

	| expressao1
	MAIOR 
	expressao1 {Code_useOp(&CODE, ">");}

	| expressao1
	MENOR 
	expressao1 {Code_useOp(&CODE, "<");}

	| expressao1
	MAIOR_IGUAL
	expressao1 {Code_useOp(&CODE, ">=");}

	| expressao1
	MENOR_IGUAL
	expressao1 {Code_useOp(&CODE, "<=");}

	;


expressao1:
	expressao2
	| expressao1 MAIS expressao2  {Code_useOp(&CODE, "+");}
	| expressao1 MENOS expressao2 {Code_useOp(&CODE, "-");}
	| expressao1 OR expressao2    {Code_useOp(&CODE, "OR");}

expressao2:
	expressao3
	| expressao2 MULT expressao3  {Code_useOp(&CODE, "*");}
	| expressao2 DIV  expressao3  {Code_useOp(&CODE, "/");}
	| expressao2 AND  expressao3  {Code_useOp(&CODE, "AND");}

expressao3:
	NUMERO       {Code_useConst(&CODE, token);}
	| expressao4 {Code_useVar(&CODE, var_token);}
	| expressao4 {strcpy(function_token, var_token);} 
	  ABRE_PARENTESES{printf("Call{name='%s';params=[", function_token);} lista_expressao FECHA_PARENTESES {printf("]};");};


expressao4:
	IDENT {strcpy(var_token, token);};

lista_expressao:
	lista_expressao VIRGULA expressao {Code_write(&CODE, nl);}
	| expressao {Code_write(&CODE, nl);}
	| ;

%%


void rpl_fprintf (char *s) {
    //fprintf (stderr, "%s\n", s);
}

main (int argc, char** argv) {
	FILE* fp;
	extern FILE* yyin;

	if (argc<2 || argc>2) {
		printf("usage compilador <arq>\n");
		return(-1);
	}

	fp=fopen (argv[1], "r");
	if (fp == NULL) {
		printf("usage compilador <arq>\n");
		return(-1);
	}

	VarPkg_init(&VARPKG);
	yyin=fp;
	if ( yyparse() ){
		printf("ERROR!\n");
	}
	return 0;
}

